%%% Filename : ac_semianc.pl
%%% Date     : 10.04.2015
%%% Contents : checks whether an analytic rule in P3 is semi-anchored
%%% Author   : Paolo Baldi <baldi@logic.at>


unanchored(U,[Lx,Rx],Con) :- 
	preprocess([Lx,Rx],[Lxp,Rx]), 
	goodsbs2(U,Lxp), 
	forall(member([Cl,Cr],Con), disjointpair(U,Rx,[Cl,Cr])).

disjointpair(_,Rx,[_,C2]) :-
	C2 \= Rx.
disjointpair(U,Rx,[C1,Rx]) :- 
	disjoint(U,C1). 


%% anchored(U,[Lx,Rx],Con) :- 
%% 	sms(U,Lx), 
%%	member([Y1,Rx],Con), 
%%	sbs(U,Y1).

semianch(U,[Lx,Rx],Prem,Con) :- 
	member([Lx,Rx],Prem),
	preprocess([Lx,Rx],[Lxp,Rx]),          
        %% unanchored(U,[Lx,Rx],Con), 
	member([W,R1],Prem), 
	preprocess([W,R1],[Wp,R1]), 
	member([Y1,R1],Con), 
        length(U,N), 	
        smsleng(V,Wp,N), 
	substituteb(U,V,Lxp,Wp), 
	sbs(V,Y1).  


semianch(U,[Lx,Rx],Prem,Con) :- 
	member([Lx,Rx],Prem), 
	preprocess([Lx,Rx],[Lxp,Rx]), 
       %% unanchored(U,[Lx,Rx],Con), 
	member([W,R1],Prem),  
	preprocess([W,R1],[Lxp,R1]), 
	R1\=Rx, 
	member([Y1,R1],Con), 
	sbs(U,Y1).

semianch(U,[Lx,Rx],Prem,Con) :-  
	member([Lx,Rx],Prem), 
	preprocess([Lx,Rx],[Lxp,Rx]),
       %%	unanchored(U,[Lx,Rx],Con), 
	member([W,R1],Prem), 
	preprocess([W,R1],[Wp,R1]), 
	member([Y1,R1],Con), 
	member([Y2,Rx],Con), 
        length(U,N), 	
        smsleng(V,Wp,N), 
       	substituteb(U,V,Lxp,Wp), 
	sbs(U,Y1), 
	sbs(V,Y2). 
	

%% semianch(U,[Lx,Rx],Prem,Con):-  
%%	member([Lx,Rx],Prem), 
%%	preprocess([Lx,Rx],[Lxp,Rx]), 
%%	anchored(U,[Lxp,Rx],Con), 
%%	U \=[].

semianchored([Lx,Rx],Prem,Con) :- 
   forall(unanchored(U,[Lx,Rx],Con), semianch(U,[Lx,Rx],Prem,Con)).
 
%%% findall(U,unanchored(U,[Lx,Rx],Con),Z1), 
  %%% findall(U,semianch(U,[Lx,Rx],Prem,Con),Z2), 
   %%% sbs(Z1,Z2). 

semianchored([Lx,Rx],_,Con):- findall(U,unanchored(U,[Lx,Rx],Con),Z1), Z1 = [[]].

is_semianchored([Prem,Con])  :- 
    forall(member([Lx,Rx],Prem), semianchored([Lx,Rx],Prem,Con)).



is_semianchlist(L) :- 
    forall(member(X,L), is_semianchored(X)).

preprocess([Lx,''],[Lx,'']).
preprocess([Lx,Rx],[Lxp,Rx]) :- 
	removelast(Lx,Lxp).














